INTEN	=	0x7f

	.name	r1,count
	.name	r2,led
	.name	r3,tmp
	.name	r4,adr
	.name	r5,data
	.name	r6,mask
	.name	r7,maincount
	.name	r8,loopcount

	j	start
	reti
start:
	call	init
2:
	call	increment_1
	li.b	loopcount,0x20
1:
	call	mainloop
	call	decrement_all
	subi.b	loopcount,1
	jnz	1b
	j	2b

mainloop:
	li.b	data,0
	st.b	data,[led]
	li.b	count,INTEN
3:
	li.b	mask,1
	li.s	adr,0
2:
	ld.b	tmp,[adr]
	addi.s	adr,1
	cmp.b	tmp,count
	jnz	1f
	or.b	data,mask
	st.b	data,[led]
1:
	add.b	mask,mask
	jnz	2b
	subi.b	count,1
	jnz	3b
	ret

init:
	li.s	led,0x8004
	li.s	adr,0
	li.b	tmp,0
1:
	st.b	tmp,[adr]
	addi.s	adr,1
	cmpi.s	adr,8
	jc	1b
	ret

increment_1:
	mov.b	adr,maincount
	tsti.b	adr,8
	jz	1f
	li.b	adr,15
	sub.b	adr,maincount
1:
	andi.s	adr,7
	li.b	tmp,INTEN
	st.b	tmp,[adr]
	addi.b	maincount,1
	ret

decrement_all:
	li.s	adr,0
2:
	ld.b	tmp,[adr]
	cmpi.b	tmp,0
	jz	1f
	subi.b	tmp,1
	st.b	tmp,[adr]
1:
	addi.s	adr,1
	cmpi.s	adr,8
	jc	2b
	ret

